float4x4 tV: VIEW;
float4x4 tP: PROJECTION;

Texture3D texture3d <string uiname="Texture3d In";>;
SamplerState volumeSampler // : IMMUTABLE
{
	Filter = MIN_MAG_MIP_LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
	Addressw = Wrap;
};
	float4x4 tTex <string uiname="Texture Transform"; >;// bool uvspace=true; >;


float Alpha <float uimin=0.0; float uimax=1.0;> = 1;

int IntanceStartIndex = 0;
StructuredBuffer<float4x4> world;
StructuredBuffer<float3> texcords3d;

struct VS_IN
{
	uint ii : SV_InstanceID; //Object instance ID
    float4 PosO  : POSITION;
    float3 NormO : NORMAL;
    float4 TexCd : TEXCOORD0;
};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
    float3 TexCd: TEXCOORD0;
    float4 Diffuse: COLOR0;
    float4 Specular: COLOR1;
	uint ii : SV_InstanceID; //Object instance ID
//	float3 outputuv;
};



vs2ps VS(VS_IN input)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;
	
	//Get the current world transform from buffer.
	//So index is instance ID + start index
	float4x4 w = world[input.ii + IntanceStartIndex];
	float3 wn =  texcords3d[input.ii]; //get a coordinate to sample via the 3d dynamic buffer
	//Get world view transform
	float4x4 wv = mul(w,tV);
 // Out.Diffuse=tex3d.SampleLevel(volumeSampler,float3(uv),0)
    float4 PosV = mul(input.PosO, wv); //shifts to transformed position
	float4 PosWVP  = mul(PosV, tP);
	Out.PosWVP =PosWVP ;
    Out.TexCd = wn; 
    return Out;
}

float4 PS(vs2ps In): SV_Target
{
	float4 col = 1.0f; 

	col = texture3d.Sample(volumeSampler, In.TexCd);
    return col;
}

technique10 GouraudDirectional
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}

